# NFA035 TP 2 : JUnit

Note : ce tp est réalisable avec n'importe quel IDE, dont eclipse.

En mode ligne de commande, il est aussi possible de lancer la compilation et les tests. Vous pouvez taper :

~~~
mvn test
~~~
(si maven est installé sur votre machine)


ou

~~~
./mvnw test
~~~

sinon.

## Exercice 1
La classe Exo1Puissance contient une méthode qui doit calculer *aⁿ*, pour n entier positif. Les spécifications sont les suivantes :

- a est un réel, et n un entier quelconque ;
- le calcul de *aⁿ* doit lever une exception si n est strictement négatif.
- par *convention*, *0⁰ = 1*

(remarque : on pourrait autoriser *n* à être négatif, mais ça n'est pas le but de l'exercice...)

### Questions

- Faites tourner le test Exo1PuissanceTest ;
- complétez la méthode puissance pour qu'elle fonctionne ;
- testez votre méthode avec Exo1puissanceTest, et corrigez-la si nécessaire.


## Exercice 2

On vous donne une méthode (fausse) pour calculer le maximum d'un tableau : `Exo2Maximum.maximum`. 

- Lisez attentivement les spécifications de la méthode dans sa Javadoc ;

- cherchez, éventuellement **sur papier,** quels cas vous devez tester pour être raisonnablement sûr que la méthode fonctionne en suivant ces spécifications :
    - pensez d'abord au *cas général* - essayez de tester plusieurs configurations ;
    - vérifiez que le code lève les exceptions attendues ;
    - cherchez les éventuels cas limites (j'aurais tendance à tester par exemple avec une liste de longueur 1) ;
    - rappelez-vous que les entiers peuvent être aussi *négatifs*.

- écrivez les jeux de tests correspondants ;

- testez : certains tests doivent échouer ;

- corrigez les bugs, et vérifiez que les tests passent.
 

## Exercice 3 (pour aller plus loin)

Nous avons repris l'exercice `TriBugge` de la semaine dernière ; il se trouve dans la classe `Exo3Tribugge`. Nous avons enlevé les déclarations `private` devant les méthodes afin de pouvoir les tester.


- écrivez les tests pour la méthode `posPlusPetit` ; pensez à couvrir des cas assez variés, pour tous les paramètres ; comme la méthode n'est pas publique, vous n'avez pas besoin de perdre du temps avec les erreurs comme "t est nul", "t est vide", ou "départ n'est pas un indice de t".

- lancez vos tests ; ils devraient échouer (s'ils n'échouent pas, c'est que vous n'avez pas couvert assez de cas...)

- corrigez `posPlusPetit` pour que vos tests passent ;

- écrivez des tests pour `echanger` (a priori, vous n'avez pas à en écrire beaucoup) ;

- ils devraient échouer ;

- corrigez "echanger"

- écrivez quelques tests pour trier ; ils devraient normalement "passer".
