package tp2;

/**
 * Tri d'un tableau en utilisant le tri sélection. Idée :
 * On prend le plus petit élément du tableau, et on le met en premier.
 * Ensuite, on prend le plus petit élément de ce qui reste, et on le met en second...
 * etc...
 */
public class Exo3Tribugge {
	
	/**
	 * Trie le tableau t.
	 * @param t
	 */
	public static void trier(int t[]) {
		for (int i= 0; i < t.length -1 ; i++ ) {
			int pos= posPlusPetit(t, i);
			echanger(t, i, pos);
		}
	}
	
	/**
	 * échange le contenu des cases i et j du tableau t.
	 * @param t
	 * @param i
	 * @param pos
	 */
	static void echanger(int[] t, int i, int j) {
		int tmp= t[i];
		t[i]= t[j];
		t[j]= t[i];		
	}

	/**
	 * Trouve la position du plus petit élément de t à partir de l'indice depart.
	 * Retourne l'indice du plus petit élément du sous tableau de t qui commence 
	 * à l'indice depart (inclus).
	 * 
	 * <p> Formellement, retourne le plus petit i0 plus grand ou égal à depart 
	 * tel que pour tout i indice du tableau plus grand ou égal à 
	 * depart, t[i] soit plus grand ou égal à t[i0]
	 * 
	 * <p> (on précise qu'on veut le premier i0 trouvé, au cas où le plus petit 
	 * élément se trouve dupliqué, afin que la méthode n'ait qu'un résultat possible)
	 * @param t
	 * @param depart un indice de départ dans t.
	 * @return la position du plus petit élément.
	 */
	static int posPlusPetit(int[] t, int depart) {
		int resultat= 0;
		for (int j= depart; j < t.length; j++) {
			if (t[j] < t[resultat])
				resultat= j;
		}
		return resultat;
	}

	/**
	 * Affiche le tableau t.
	 * (cette méthode n'est pas à tester)
	 * @param t
	 */
	static void afficher(int t[]) {
		System.out.print("[");
		for (int i= 0; i < t.length; i++) {
			if (i!= 0) System.out.print(", ");
			System.out.print(t[i]);
		}
		System.out.println("]");
	}
	
	public static void main(String args[]) {
		int t[]= {6, 9, 1, 20, 3, 7, 10, 10, 2, 58, 20};
		trier(t);
		afficher(t);		
	}	
}
